<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import {
  CaseStudyContentArea,
  CaseStudyHero,
  CaseStudyPricingPlans,
  CaseStudyStickySidebar,
  CaseStudyCustomerSuccessStories,
} from '~/components/customers/index.vue';
import { NextStep } from '~/components/common/index';

import { getPageMetadata } from '~/common/meta';

export default Vue.extend({
  components: {
    CaseStudyContentArea,
    CaseStudyHero,
    CaseStudyPricingPlans,
    CaseStudyStickySidebar,
    CaseStudyCustomerSuccessStories,
    NextStep,
  },
  async asyncData({ $content, params, error }: any) {
    try {
      const templateData = await $content('customers/base_template').fetch();
      const caseStudyData = await $content(`customers/${params.slug}`).fetch();

      const data = { ...templateData.data, ...caseStudyData.data };
      data.title = data.customer;

      data.crumbs.push({ title: data.customer });

      return { data };
    } catch (e) {
      return error({ statusCode: 404 });
    }
  },
  head(): MetaInfo {
    return getPageMetadata((this as any).data, this.$route.path);
  },
});
</script>

<template>
  <div>
    <CaseStudyHero :data="data" />

    <section>
      <SlpContainer class="slp-flex">
        <CaseStudyStickySidebar :data="data" />
        <CaseStudyContentArea :data="data" />
      </SlpContainer>
    </section>

    <CaseStudyPricingPlans :data="data" />

    <CaseStudyCustomerSuccessStories :data="data" />

    <section class="slp-mt-96">
      <SlpContainer variant="gradient">
        <NextStep />
      </SlpContainer>
    </section>
  </div>
</template>
